3 # Copyright (C) The Arvados Authors. All rights reserved.
5 # SPDX-License-Identifier: CC-BY-SA-3.0
7 # If you want to test arvados in a single host, you can run this script, which
8 # will install it using salt masterless
9 # This script is run by the Vagrant file when you run it with
15 # capture the directory that the script is running from
16 SCRIPT_DIR="$( cd "$( dirname "${BASH_SOURCE[0]}" )" >/dev/null 2>&1 && pwd )"
20 echo >&2 "Usage: ${0} [-h] [-h]"
22 echo >&2 "${0} options:"
23 echo >&2 " -d, --debug Run salt installation in debug mode"
24 echo >&2 " -c <local.params>, --config <local.params> Path to the local.params config file"
25 echo >&2 " -t, --test Test installation running a CWL workflow"
26 echo >&2 " -r, --roles List of Arvados roles to apply to the host, comma separated"
27 echo >&2 " Possible values are:"
29 echo >&2 " controller"
30 echo >&2 " dispatcher"
32 echo >&2 " keepbalance"
39 echo >&2 " workbench2"
40 echo >&2 " Defaults to applying them all"
41 echo >&2 " -h, --help Display this help and exit"
42 echo >&2 " --dump-config <dest_dir> Dumps the pillars and states to a directory"
43 echo >&2 " This parameter does not perform any installation at all. It's"
44 echo >&2 " intended to give you a parsed set of configuration files so"
45 echo >&2 " you can inspect them or use them in you Saltstack infrastructure."
47 echo >&2 " - parses the pillar and states templates,"
48 echo >&2 " - downloads the helper formulas with their desired versions,"
49 echo >&2 " - prepares the 'top.sls' files both for pillars and states"
50 echo >&2 " for the selected role(s)"
51 echo >&2 " - writes the resulting files into <dest_dir>"
52 echo >&2 " -v, --vagrant Run in vagrant and use the /vagrant shared dir"
53 echo >&2 " --development Run in dev mode, using snakeoil certs"
58 # NOTE: This requires GNU getopt (part of the util-linux package on Debian-based distros).
59 if ! which getopt > /dev/null; then
60 echo >&2 "GNU getopt is required to run this script. Please install it and re-reun it"
64 TEMP=$(getopt -o c:dhp:r:tv \
65 --long config:,debug,development,dump-config:,help,roles:,test,vagrant \
69 then echo "Please check the parameters you entered and re-run again"
72 # Note the quotes around `$TEMP': they are essential!
75 while [ ${#} -ge 1 ]; do
87 if [[ ${2} = /* ]]; then
88 DUMP_SALT_CONFIG_DIR=${2}
90 DUMP_SALT_CONFIG_DIR=${PWD}/${2}
93 S_DIR="${DUMP_SALT_CONFIG_DIR}/salt"
95 F_DIR="${DUMP_SALT_CONFIG_DIR}/formulas"
97 P_DIR="${DUMP_SALT_CONFIG_DIR}/pillars"
99 T_DIR="${DUMP_SALT_CONFIG_DIR}/tests"
110 # Verify the role exists
111 if [[ ! "database,api,controller,keepstore,websocket,keepweb,workbench2,webshell,keepbalance,keepproxy,shell,workbench,dispatcher" == *"$i"* ]]; then
112 echo "The role '${i}' is not a valid role"
116 ROLES="${ROLES} ${i}"
144 mkdir -p /srv/salt/certs
145 chmod 700 /srv/salt/certs
147 if [ -f ${cert_dir}/${cert_name}.crt ]; then
148 cp -v ${cert_dir}/${cert_name}.crt /srv/salt/certs/arvados-${cert_name}.pem
149 chmod 600 /srv/salt/certs/arvados-${cert_name}.pem
151 echo "${cert_dir}/${cert_name}.crt does not exist. Exiting"
154 if [ -f ${cert_dir}/${cert_name}.key ]; then
155 cp -v ${cert_dir}/${cert_name}.key /srv/salt/certs/arvados-${cert_name}.key
156 chmod 600 /srv/salt/certs/arvados-${cert_name}.key
158 echo "${cert_dir}/${cert_name}.key does not exist. Exiting"
164 CONFIG_FILE="${SCRIPT_DIR}/local.params"
165 CONFIG_DIR="local_config_dir"
168 CONTROLLER_EXT_SSL_PORT=443
171 NGINX_INSTALL_SOURCE="install_from_repo"
176 # Hostnames/IPs used for single-host deploys
181 INITIAL_USER_EMAIL=""
182 INITIAL_USER_PASSWORD=""
184 CONTROLLER_EXT_SSL_PORT=8000
185 KEEP_EXT_SSL_PORT=25101
186 # Both for collections and downloads
187 KEEPWEB_EXT_SSL_PORT=9002
188 WEBSHELL_EXT_SSL_PORT=4202
189 WEBSOCKET_EXT_SSL_PORT=8002
190 WORKBENCH1_EXT_SSL_PORT=443
191 WORKBENCH2_EXT_SSL_PORT=3001
193 SSL_MODE="self-signed"
194 USE_LETSENCRYPT_ROUTE53="no"
195 CUSTOM_CERTS_DIR="${SCRIPT_DIR}/local_config_dir/certs"
197 ## These are ARVADOS-related parameters
198 # For a stable release, change RELEASE "production" and VERSION to the
199 # package version (including the iteration, e.g. X.Y.Z-1) of the
201 # The "local.params.example.*" files already set "RELEASE=production"
202 # to deploy production-ready packages
203 RELEASE="development"
206 # These are arvados-formula-related parameters
207 # An arvados-formula tag. For a stable release, this should be a
208 # branch name (e.g. X.Y-dev) or tag for the release.
209 # ARVADOS_TAG="2.2.0"
212 # We pin the salt version to avoid potential incompatibilities when a new
213 # stable version is released.
216 # Other formula versions we depend on
217 #POSTGRES_TAG="v0.44.0"
218 #POSTGRES_URL="https://github.com/saltstack-formulas/postgres-formula.git"
219 POSTGRES_TAG="0.45.0-bugfix327"
220 POSTGRES_URL="https://github.com/arvados/postgres-formula.git"
224 LETSENCRYPT_TAG="v2.1.0"
225 LOGROTATE_TAG="v0.14.0"
228 DUMP_SALT_CONFIG_DIR=""
232 F_DIR="/srv/formulas"
236 T_DIR="/tmp/cluster_tests"
242 if [ -s ${CONFIG_FILE} ]; then
243 source ${CONFIG_FILE}
245 echo >&2 "You don't seem to have a config file with initial values."
246 echo >&2 "Please create a '${CONFIG_FILE}' file as described in"
247 echo >&2 " * https://doc.arvados.org/install/salt-single-host.html#single_host, or"
248 echo >&2 " * https://doc.arvados.org/install/salt-multi-host.html#multi_host_multi_hostnames"
252 if [ ! -d ${CONFIG_DIR} ]; then
253 echo >&2 "You don't seem to have a config directory with pillars and states."
254 echo >&2 "Please create a '${CONFIG_DIR}' directory (as configured in your '${CONFIG_FILE}'). Please see"
255 echo >&2 " * https://doc.arvados.org/install/salt-single-host.html#single_host, or"
256 echo >&2 " * https://doc.arvados.org/install/salt-multi-host.html#multi_host_multi_hostnames"
260 if grep -rni 'fixme' ${CONFIG_FILE} ${CONFIG_DIR} ; then
261 echo >&2 "The config file ${CONFIG_FILE} has some parameters that need to be modified."
262 echo >&2 "Please, fix them and re-run the provision script."
266 if ! grep -qE '^[[:alnum:]]{5}$' <<<${CLUSTER} ; then
267 echo >&2 "ERROR: <CLUSTER> must be exactly 5 lowercase alphanumeric characters long"
268 echo >&2 "Fix the cluster name in the 'local.params' file and re-run the provision script"
272 # Only used in single_host/single_name deploys
273 if [ ! -z "${HOSTNAME_EXT}" ] ; then
274 # We need to add some extra control vars to manage a single certificate vs. multiple
275 USE_SINGLE_HOSTNAME="yes"
276 # Make sure that the value configured as IP_INT is a real IP on the system.
277 # If we don't error out early here when there is a mismatch, the formula will
278 # fail with hard to interpret nginx errors later on.
279 ip addr list |grep "${IP_INT}/" >/dev/null
280 if [[ $? -ne 0 ]]; then
281 echo "Unable to find the IP_INT address '${IP_INT}' on the system, please correct the value in local.params. Exiting..."
285 USE_SINGLE_HOSTNAME="no"
286 # We set this variable, anyway, so sed lines do not fail and we don't need to add more
288 HOSTNAME_EXT="${CLUSTER}.${DOMAIN}"
291 if [ "${DUMP_CONFIG}" = "yes" ]; then
292 echo "The provision installer will just dump a config under ${DUMP_SALT_CONFIG_DIR} and exit"
294 # Install a few dependency packages
295 # First, let's figure out the OS we're working on
296 OS_ID=$(grep ^ID= /etc/os-release |cut -f 2 -d= |cut -f 2 -d \")
297 echo "Detected distro: ${OS_ID}"
301 echo "WARNING! Disabling SELinux, see https://dev.arvados.org/issues/18019"
302 sed -i 's/SELINUX=enforcing/SELINUX=permissive/g' /etc/sysconfig/selinux
303 setenforce permissive
304 yum install -y curl git jq
307 # Wait 2 minutes for any apt locks to clear
308 # This option is supported from apt 1.9.1 and ignored in older apt versions.
309 # Cf. https://blog.sinjakli.co.uk/2021/10/25/waiting-for-apt-locks-without-the-hacky-bash-scripts/
310 DEBIAN_FRONTEND=noninteractive apt -o DPkg::Lock::Timeout=120 update
311 DEBIAN_FRONTEND=noninteractive apt install -y curl git jq
315 if which salt-call; then
316 echo "Salt already installed"
318 curl -L https://bootstrap.saltstack.com -o /tmp/bootstrap_salt.sh
319 sh /tmp/bootstrap_salt.sh -XdfP -x python3 stable ${SALT_VERSION}
320 /bin/systemctl stop salt-minion.service
321 /bin/systemctl disable salt-minion.service
324 # Set salt to masterless mode
325 cat > /etc/salt/minion << EOFSM
340 mkdir -p ${S_DIR} ${F_DIR} ${P_DIR} ${T_DIR}
342 # Get the formula and dependencies
343 cd ${F_DIR} || exit 1
344 echo "Cloning formulas"
345 test -d docker && ( cd docker && git fetch ) \
346 || git clone --quiet https://github.com/saltstack-formulas/docker-formula.git ${F_DIR}/docker
347 ( cd docker && git checkout --quiet tags/"${DOCKER_TAG}" )
350 test -d locale && ( cd locale && git fetch ) \
351 || git clone --quiet https://github.com/saltstack-formulas/locale-formula.git ${F_DIR}/locale
352 ( cd locale && git checkout --quiet tags/"${LOCALE_TAG}" )
355 test -d nginx && ( cd nginx && git fetch ) \
356 || git clone --quiet https://github.com/saltstack-formulas/nginx-formula.git ${F_DIR}/nginx
357 ( cd nginx && git checkout --quiet tags/"${NGINX_TAG}" )
360 test -d postgres && ( cd postgres && git fetch ) \
361 || git clone --quiet ${POSTGRES_URL} ${F_DIR}/postgres
362 ( cd postgres && git checkout --quiet tags/"${POSTGRES_TAG}" )
364 echo "...letsencrypt"
365 test -d letsencrypt && ( cd letsencrypt && git fetch ) \
366 || git clone --quiet https://github.com/saltstack-formulas/letsencrypt-formula.git ${F_DIR}/letsencrypt
367 ( cd letsencrypt && git checkout --quiet tags/"${LETSENCRYPT_TAG}" )
370 test -d logrotate && ( cd logrotate && git fetch ) \
371 || git clone --quiet https://github.com/saltstack-formulas/logrotate-formula.git ${F_DIR}/logrotate
372 ( cd logrotate && git checkout --quiet tags/"${LOGROTATE_TAG}" )
375 test -d arvados || git clone --quiet https://git.arvados.org/arvados-formula.git ${F_DIR}/arvados
377 # If we want to try a specific branch of the formula
378 if [ "x${BRANCH}" != "x" ]; then
379 ( cd ${F_DIR}/arvados && git checkout --quiet -t origin/"${BRANCH}" -b "${BRANCH}" )
380 elif [ "x${ARVADOS_TAG}" != "x" ]; then
381 ( cd ${F_DIR}/arvados && git checkout --quiet tags/"${ARVADOS_TAG}" -b "${ARVADOS_TAG}" )
384 if [ "x${VAGRANT}" = "xyes" ]; then
385 EXTRA_STATES_DIR="/home/vagrant/${CONFIG_DIR}/states"
386 SOURCE_PILLARS_DIR="/home/vagrant/${CONFIG_DIR}/pillars"
387 SOURCE_TESTS_DIR="/home/vagrant/${TESTS_DIR}"
389 EXTRA_STATES_DIR="${SCRIPT_DIR}/${CONFIG_DIR}/states"
390 SOURCE_PILLARS_DIR="${SCRIPT_DIR}/${CONFIG_DIR}/pillars"
391 SOURCE_TESTS_DIR="${SCRIPT_DIR}/${TESTS_DIR}"
394 SOURCE_STATES_DIR="${EXTRA_STATES_DIR}"
396 echo "Writing pillars and states"
398 # Replace variables (cluster, domain, etc) in the pillars, states and tests
399 # to ease deployment for newcomers
400 if [ ! -d "${SOURCE_PILLARS_DIR}" ]; then
401 echo "${SOURCE_PILLARS_DIR} does not exist or is not a directory. Exiting."
404 for f in $(ls "${SOURCE_PILLARS_DIR}"/*); do
405 sed "s#__ANONYMOUS_USER_TOKEN__#${ANONYMOUS_USER_TOKEN}#g;
406 s#__BLOB_SIGNING_KEY__#${BLOB_SIGNING_KEY}#g;
407 s#__CONTROLLER_EXT_SSL_PORT__#${CONTROLLER_EXT_SSL_PORT}#g;
408 s#__CLUSTER__#${CLUSTER}#g;
409 s#__DOMAIN__#${DOMAIN}#g;
410 s#__HOSTNAME_EXT__#${HOSTNAME_EXT}#g;
411 s#__IP_INT__#${IP_INT}#g;
412 s#__INITIAL_USER_EMAIL__#${INITIAL_USER_EMAIL}#g;
413 s#__INITIAL_USER_PASSWORD__#${INITIAL_USER_PASSWORD}#g;
414 s#__INITIAL_USER__#${INITIAL_USER}#g;
415 s#__LE_AWS_REGION__#${LE_AWS_REGION}#g;
416 s#__LE_AWS_SECRET_ACCESS_KEY__#${LE_AWS_SECRET_ACCESS_KEY}#g;
417 s#__LE_AWS_ACCESS_KEY_ID__#${LE_AWS_ACCESS_KEY_ID}#g;
418 s#__DATABASE_PASSWORD__#${DATABASE_PASSWORD}#g;
419 s#__KEEPWEB_EXT_SSL_PORT__#${KEEPWEB_EXT_SSL_PORT}#g;
420 s#__KEEP_EXT_SSL_PORT__#${KEEP_EXT_SSL_PORT}#g;
421 s#__MANAGEMENT_TOKEN__#${MANAGEMENT_TOKEN}#g;
422 s#__RELEASE__#${RELEASE}#g;
423 s#__SYSTEM_ROOT_TOKEN__#${SYSTEM_ROOT_TOKEN}#g;
424 s#__VERSION__#${VERSION}#g;
425 s#__WEBSHELL_EXT_SSL_PORT__#${WEBSHELL_EXT_SSL_PORT}#g;
426 s#__WEBSOCKET_EXT_SSL_PORT__#${WEBSOCKET_EXT_SSL_PORT}#g;
427 s#__WORKBENCH1_EXT_SSL_PORT__#${WORKBENCH1_EXT_SSL_PORT}#g;
428 s#__WORKBENCH2_EXT_SSL_PORT__#${WORKBENCH2_EXT_SSL_PORT}#g;
429 s#__CLUSTER_INT_CIDR__#${CLUSTER_INT_CIDR}#g;
430 s#__CONTROLLER_INT_IP__#${CONTROLLER_INT_IP}#g;
431 s#__WEBSOCKET_INT_IP__#${WEBSOCKET_INT_IP}#g;
432 s#__KEEP_INT_IP__#${KEEP_INT_IP}#g;
433 s#__KEEPSTORE0_INT_IP__#${KEEPSTORE0_INT_IP}#g;
434 s#__KEEPSTORE1_INT_IP__#${KEEPSTORE1_INT_IP}#g;
435 s#__KEEPWEB_INT_IP__#${KEEPWEB_INT_IP}#g;
436 s#__WEBSHELL_INT_IP__#${WEBSHELL_INT_IP}#g;
437 s#__SHELL_INT_IP__#${SHELL_INT_IP}#g;
438 s#__WORKBENCH1_INT_IP__#${WORKBENCH1_INT_IP}#g;
439 s#__WORKBENCH2_INT_IP__#${WORKBENCH2_INT_IP}#g;
440 s#__DATABASE_INT_IP__#${DATABASE_INT_IP}#g;
441 s#__WORKBENCH_SECRET_KEY__#${WORKBENCH_SECRET_KEY}#g;
442 s#__SSL_KEY_ENCRYPTED__#${SSL_KEY_ENCRYPTED}#g;
443 s#__SSL_KEY_AWS_SECRET_NAME__#${SSL_KEY_AWS_SECRET_NAME}#g" \
444 "${f}" > "${P_DIR}"/$(basename "${f}")
447 if [ ! -d "${SOURCE_TESTS_DIR}" ]; then
448 echo "WARNING: The tests directory was not copied to \"${SOURCE_TESTS_DIR}\"."
449 if [ "x${TEST}" = "xyes" ]; then
450 echo "WARNING: Disabling tests for this installation."
455 # Replace cluster and domain name in the test files
456 for f in $(ls "${SOURCE_TESTS_DIR}"/*); do
457 FILTERS="s#__CLUSTER__#${CLUSTER}#g;
458 s#__CONTROLLER_EXT_SSL_PORT__#${CONTROLLER_EXT_SSL_PORT}#g;
459 s#__DOMAIN__#${DOMAIN}#g;
460 s#__IP_INT__#${IP_INT}#g;
461 s#__INITIAL_USER_EMAIL__#${INITIAL_USER_EMAIL}#g;
462 s#__INITIAL_USER_PASSWORD__#${INITIAL_USER_PASSWORD}#g
463 s#__INITIAL_USER__#${INITIAL_USER}#g;
464 s#__DATABASE_PASSWORD__#${DATABASE_PASSWORD}#g;
465 s#__SYSTEM_ROOT_TOKEN__#${SYSTEM_ROOT_TOKEN}#g"
466 if [ "$USE_SINGLE_HOSTNAME" = "yes" ]; then
467 FILTERS="s#__CLUSTER__.__DOMAIN__#${HOSTNAME_EXT}#g;
471 "${f}" > ${T_DIR}/$(basename "${f}")
473 chmod 755 ${T_DIR}/run-test.sh
476 # Replace helper state files that differ from the formula's examples
477 if [ -d "${SOURCE_STATES_DIR}" ]; then
478 mkdir -p "${F_DIR}"/extra/extra
480 for f in $(ls "${SOURCE_STATES_DIR}"/*); do
481 sed "s#__ANONYMOUS_USER_TOKEN__#${ANONYMOUS_USER_TOKEN}#g;
482 s#__CLUSTER__#${CLUSTER}#g;
483 s#__BLOB_SIGNING_KEY__#${BLOB_SIGNING_KEY}#g;
484 s#__CONTROLLER_EXT_SSL_PORT__#${CONTROLLER_EXT_SSL_PORT}#g;
485 s#__DOMAIN__#${DOMAIN}#g;
486 s#__HOSTNAME_EXT__#${HOSTNAME_EXT}#g;
487 s#__IP_INT__#${IP_INT}#g;
488 s#__INITIAL_USER_EMAIL__#${INITIAL_USER_EMAIL}#g;
489 s#__INITIAL_USER_PASSWORD__#${INITIAL_USER_PASSWORD}#g;
490 s#__INITIAL_USER__#${INITIAL_USER}#g;
491 s#__DATABASE_PASSWORD__#${DATABASE_PASSWORD}#g;
492 s#__KEEPWEB_EXT_SSL_PORT__#${KEEPWEB_EXT_SSL_PORT}#g;
493 s#__KEEP_EXT_SSL_PORT__#${KEEP_EXT_SSL_PORT}#g;
494 s#__MANAGEMENT_TOKEN__#${MANAGEMENT_TOKEN}#g;
495 s#__RELEASE__#${RELEASE}#g;
496 s#__SYSTEM_ROOT_TOKEN__#${SYSTEM_ROOT_TOKEN}#g;
497 s#__VERSION__#${VERSION}#g;
498 s#__CLUSTER_INT_CIDR__#${CLUSTER_INT_CIDR}#g;
499 s#__CONTROLLER_INT_IP__#${CONTROLLER_INT_IP}#g;
500 s#__WEBSOCKET_INT_IP__#${WEBSOCKET_INT_IP}#g;
501 s#__KEEP_INT_IP__#${KEEP_INT_IP}#g;
502 s#__KEEPSTORE0_INT_IP__#${KEEPSTORE0_INT_IP}#g;
503 s#__KEEPSTORE1_INT_IP__#${KEEPSTORE1_INT_IP}#g;
504 s#__KEEPWEB_INT_IP__#${KEEPWEB_INT_IP}#g;
505 s#__WEBSHELL_INT_IP__#${WEBSHELL_INT_IP}#g;
506 s#__WORKBENCH1_INT_IP__#${WORKBENCH1_INT_IP}#g;
507 s#__WORKBENCH2_INT_IP__#${WORKBENCH2_INT_IP}#g;
508 s#__DATABASE_INT_IP__#${DATABASE_INT_IP}#g;
509 s#__WEBSHELL_EXT_SSL_PORT__#${WEBSHELL_EXT_SSL_PORT}#g;
510 s#__SHELL_INT_IP__#${SHELL_INT_IP}#g;
511 s#__WEBSOCKET_EXT_SSL_PORT__#${WEBSOCKET_EXT_SSL_PORT}#g;
512 s#__WORKBENCH1_EXT_SSL_PORT__#${WORKBENCH1_EXT_SSL_PORT}#g;
513 s#__WORKBENCH2_EXT_SSL_PORT__#${WORKBENCH2_EXT_SSL_PORT}#g;
514 s#__WORKBENCH_SECRET_KEY__#${WORKBENCH_SECRET_KEY}#g;
515 s#__SSL_KEY_ENCRYPTED__#${SSL_KEY_ENCRYPTED}#g;
516 s#__SSL_KEY_AWS_SECRET_NAME__#${SSL_KEY_AWS_SECRET_NAME}#g" \
517 "${f}" > "${F_DIR}/extra/extra"/$(basename "${f}")
521 # Now, we build the SALT states/pillars trees
522 # As we need to separate both states and pillars in case we want specific
523 # roles, we iterate on both at the same time
526 cat > ${S_DIR}/top.sls << EOFTSLS
533 cat > ${P_DIR}/top.sls << EOFPSLS
540 # States, extra states
541 if [ -d "${F_DIR}"/extra/extra ]; then
542 SKIP_SNAKE_OIL="snakeoil_certs"
544 if [[ "$DEV_MODE" = "yes" || "${SSL_MODE}" == "self-signed" ]] ; then
545 # In dev mode, we create some snake oil certs that we'll
546 # use as CUSTOM_CERTS, so we don't skip the states file.
547 # Same when using self-signed certificates.
548 SKIP_SNAKE_OIL="dont_add_snakeoil_certs"
550 for f in $(ls "${F_DIR}"/extra/extra/*.sls | egrep -v "${SKIP_SNAKE_OIL}|shell_"); do
551 echo " - extra.$(basename ${f} | sed 's/.sls$//g')" >> ${S_DIR}/top.sls
553 # Use byo or self-signed certificates
554 if [ "${SSL_MODE}" != "lets-encrypt" ]; then
555 mkdir -p "${F_DIR}"/extra/extra/files
559 # If we want specific roles for a node, just add the desired states
560 # and its dependencies
561 if [ -z "${ROLES}" ]; then
563 echo " - nginx.passenger" >> ${S_DIR}/top.sls
564 if [ "${SSL_MODE}" = "lets-encrypt" ]; then
565 if [ "${USE_LETSENCRYPT_ROUTE53}" = "yes" ]; then
566 grep -q "aws_credentials" ${S_DIR}/top.sls || echo " - extra.aws_credentials" >> ${S_DIR}/top.sls
568 grep -q "letsencrypt" ${S_DIR}/top.sls || echo " - letsencrypt" >> ${S_DIR}/top.sls
570 mkdir -p /srv/salt/certs
571 chmod 700 /srv/salt/certs
572 if [ "${SSL_MODE}" = "bring-your-own" ]; then
573 # Copy certs to formula extra/files
574 cp -rv ${CUSTOM_CERTS_DIR}/* /srv/salt/certs/
575 chmod 600 /srv/salt/certs/*
576 # We add the custom_certs state
577 grep -q "custom_certs" ${S_DIR}/top.sls || echo " - extra.custom_certs" >> ${S_DIR}/top.sls
578 if [ "${SSL_KEY_ENCRYPTED}" = "yes" ]; then
579 grep -q "ssl_key_encrypted" ${S_DIR}/top.sls || echo " - extra.ssl_key_encrypted" >> ${S_DIR}/top.sls
582 # In self-signed mode, the certificate files will be created and put in the
583 # destination directory by the snakeoil_certs.sls state file
586 echo " - postgres" >> ${S_DIR}/top.sls
587 echo " - logrotate" >> ${S_DIR}/top.sls
588 echo " - docker.software" >> ${S_DIR}/top.sls
589 echo " - arvados" >> ${S_DIR}/top.sls
590 echo " - extra.shell_sudo_passwordless" >> ${S_DIR}/top.sls
591 echo " - extra.shell_cron_add_login_sync" >> ${S_DIR}/top.sls
592 echo " - extra.passenger_rvm" >> ${S_DIR}/top.sls
595 echo " - docker" >> ${P_DIR}/top.sls
596 echo " - nginx_api_configuration" >> ${P_DIR}/top.sls
597 echo " - logrotate_api" >> ${P_DIR}/top.sls
598 echo " - nginx_controller_configuration" >> ${P_DIR}/top.sls
599 echo " - nginx_keepproxy_configuration" >> ${P_DIR}/top.sls
600 echo " - nginx_keepweb_configuration" >> ${P_DIR}/top.sls
601 echo " - nginx_passenger" >> ${P_DIR}/top.sls
602 echo " - nginx_websocket_configuration" >> ${P_DIR}/top.sls
603 echo " - nginx_webshell_configuration" >> ${P_DIR}/top.sls
604 echo " - nginx_workbench2_configuration" >> ${P_DIR}/top.sls
605 echo " - nginx_workbench_configuration" >> ${P_DIR}/top.sls
606 echo " - logrotate_wb1" >> ${P_DIR}/top.sls
607 echo " - postgresql" >> ${P_DIR}/top.sls
609 # We need to tweak the Nginx's pillar depending whether we want plan nginx or nginx+passenger
610 NGINX_INSTALL_SOURCE="install_from_phusionpassenger"
611 sed -i "s/__NGINX_INSTALL_SOURCE__/${NGINX_INSTALL_SOURCE}/g" ${P_DIR}/nginx_passenger.sls
613 if [ "${SSL_MODE}" = "lets-encrypt" ]; then
614 if [ "${USE_LETSENCRYPT_ROUTE53}" = "yes" ]; then
615 grep -q "aws_credentials" ${P_DIR}/top.sls || echo " - aws_credentials" >> ${P_DIR}/top.sls
617 grep -q "letsencrypt" ${P_DIR}/top.sls || echo " - letsencrypt" >> ${P_DIR}/top.sls
619 hosts=("controller" "websocket" "workbench" "workbench2" "webshell" "keepproxy")
620 if [ ${USE_SINGLE_HOSTNAME} = "no" ]; then
621 hosts+=("download" "collections")
626 for c in "${hosts[@]}"; do
627 # Are we in a single-host-single-hostname env?
628 if [ "${USE_SINGLE_HOSTNAME}" = "yes" ]; then
629 # Are we in a single-host-single-hostname env?
630 CERT_NAME=${HOSTNAME_EXT}
632 # We are in a multiple-hostnames env
633 CERT_NAME=${c}.${CLUSTER}.${DOMAIN}
636 # As the pillar differs whether we use LE or custom certs, we need to do a final edition on them
637 sed -i "s/__CERT_REQUIRES__/cmd: create-initial-cert-${CERT_NAME}*/g;
638 s#__CERT_PEM__#/etc/letsencrypt/live/${CERT_NAME}/fullchain.pem#g;
639 s#__CERT_KEY__#/etc/letsencrypt/live/${CERT_NAME}/privkey.pem#g" \
640 ${P_DIR}/nginx_${c}_configuration.sls
643 # Use custom certs (either dev mode or prod)
644 grep -q "extra_custom_certs" ${P_DIR}/top.sls || echo " - extra_custom_certs" >> ${P_DIR}/top.sls
645 # And add the certs in the custom_certs pillar
646 echo "extra_custom_certs_dir: /srv/salt/certs" > ${P_DIR}/extra_custom_certs.sls
647 echo "extra_custom_certs:" >> ${P_DIR}/extra_custom_certs.sls
649 for c in controller websocket workbench workbench2 webshell keepweb keepproxy; do
650 # Are we in a single-host-single-hostname env?
651 if [ "${USE_SINGLE_HOSTNAME}" = "yes" ]; then
652 # Are we in a single-host-single-hostname env?
653 CERT_NAME=${HOSTNAME_EXT}
655 # We are in a multiple-hostnames env
659 if [[ "$SSL_MODE" == "bring-your-own" ]]; then
660 copy_custom_cert ${CUSTOM_CERTS_DIR} ${CERT_NAME}
663 grep -q ${CERT_NAME} ${P_DIR}/extra_custom_certs.sls || echo " - ${CERT_NAME}" >> ${P_DIR}/extra_custom_certs.sls
665 # As the pillar differs whether we use LE or custom certs, we need to do a final edition on them
666 sed -i "s/__CERT_REQUIRES__/file: extra_custom_certs_file_copy_arvados-${CERT_NAME}.pem/g;
667 s#__CERT_PEM__#/etc/nginx/ssl/arvados-${CERT_NAME}.pem#g;
668 s#__CERT_KEY__#/etc/nginx/ssl/arvados-${CERT_NAME}.key#g" \
669 ${P_DIR}/nginx_${c}_configuration.sls
673 # If we add individual roles, make sure we add the repo first
674 echo " - arvados.repo" >> ${S_DIR}/top.sls
675 # We add the extra_custom_certs state
676 grep -q "extra.custom_certs" ${S_DIR}/top.sls || echo " - extra.custom_certs" >> ${S_DIR}/top.sls
677 if [ "${SSL_KEY_ENCRYPTED}" = "yes" ]; then
678 grep -q "ssl_key_encrypted" ${S_DIR}/top.sls || echo " - extra.ssl_key_encrypted" >> ${S_DIR}/top.sls
681 # And we add the basic part for the certs pillar
682 if [ "${SSL_MODE}" != "lets-encrypt" ]; then
683 # And add the certs in the custom_certs pillar
684 echo "extra_custom_certs_dir: /srv/salt/certs" > ${P_DIR}/extra_custom_certs.sls
685 echo "extra_custom_certs:" >> ${P_DIR}/extra_custom_certs.sls
686 grep -q "extra_custom_certs" ${P_DIR}/top.sls || echo " - extra_custom_certs" >> ${P_DIR}/top.sls
689 for R in ${ROLES}; do
693 echo " - postgres" >> ${S_DIR}/top.sls
695 echo ' - postgresql' >> ${P_DIR}/top.sls
699 grep -q " - logrotate" ${S_DIR}/top.sls || echo " - logrotate" >> ${S_DIR}/top.sls
700 if grep -q " - nginx.*$" ${S_DIR}/top.sls; then
701 sed -i s/"^ - nginx.*$"/" - nginx.passenger"/g ${S_DIR}/top.sls
703 echo " - nginx.passenger" >> ${S_DIR}/top.sls
705 echo " - extra.passenger_rvm" >> ${S_DIR}/top.sls
706 ### If we don't install and run LE before arvados-api-server, it fails and breaks everything
707 ### after it. So we add this here as we are, after all, sharing the host for api and controller
708 if [ "${SSL_MODE}" = "lets-encrypt" ]; then
709 if [ "${USE_LETSENCRYPT_ROUTE53}" = "yes" ]; then
710 grep -q "aws_credentials" ${S_DIR}/top.sls || echo " - aws_credentials" >> ${S_DIR}/top.sls
712 grep -q "letsencrypt" ${S_DIR}/top.sls || echo " - letsencrypt" >> ${S_DIR}/top.sls
715 if [ "${SSL_MODE}" = "bring-your-own" ]; then
716 copy_custom_cert ${CUSTOM_CERTS_DIR} controller
718 grep -q controller ${P_DIR}/extra_custom_certs.sls || echo " - controller" >> ${P_DIR}/extra_custom_certs.sls
720 grep -q "arvados.${R}" ${S_DIR}/top.sls || echo " - arvados.${R}" >> ${S_DIR}/top.sls
722 grep -q "logrotate_api" ${P_DIR}/top.sls || echo " - logrotate_api" >> ${P_DIR}/top.sls
723 grep -q "aws_credentials" ${P_DIR}/top.sls || echo " - aws_credentials" >> ${P_DIR}/top.sls
724 grep -q "postgresql" ${P_DIR}/top.sls || echo " - postgresql" >> ${P_DIR}/top.sls
725 grep -q "nginx_passenger" ${P_DIR}/top.sls || echo " - nginx_passenger" >> ${P_DIR}/top.sls
726 grep -q "nginx_${R}_configuration" ${P_DIR}/top.sls || echo " - nginx_${R}_configuration" >> ${P_DIR}/top.sls
728 # We need to tweak the Nginx's pillar depending whether we want plain nginx or nginx+passenger
729 NGINX_INSTALL_SOURCE="install_from_phusionpassenger"
730 sed -i "s/__NGINX_INSTALL_SOURCE__/${NGINX_INSTALL_SOURCE}/g" ${P_DIR}/nginx_passenger.sls
732 "controller" | "websocket" | "workbench" | "workbench2" | "webshell" | "keepweb" | "keepproxy")
734 if [ "${R}" = "workbench" ]; then
735 grep -q " - logrotate" ${S_DIR}/top.sls || echo " - logrotate" >> ${S_DIR}/top.sls
736 NGINX_INSTALL_SOURCE="install_from_phusionpassenger"
737 if grep -q " - nginx$" ${S_DIR}/top.sls; then
738 sed -i s/"^ - nginx.*$"/" - nginx.passenger"/g ${S_DIR}/top.sls
740 echo " - nginx.passenger" >> ${S_DIR}/top.sls
743 grep -q "nginx" ${S_DIR}/top.sls || echo " - nginx" >> ${S_DIR}/top.sls
745 if [ "${SSL_MODE}" = "lets-encrypt" ]; then
746 if [ "x${USE_LETSENCRYPT_ROUTE53}" = "xyes" ]; then
747 grep -q "aws_credentials" ${S_DIR}/top.sls || echo " - aws_credentials" >> ${S_DIR}/top.sls
749 grep -q "letsencrypt" ${S_DIR}/top.sls || echo " - letsencrypt" >> ${S_DIR}/top.sls
751 # Use custom certs, special case for keepweb
752 if [ ${R} = "keepweb" ]; then
753 if [ "${SSL_MODE}" = "bring-your-own" ]; then
754 copy_custom_cert ${CUSTOM_CERTS_DIR} download
755 copy_custom_cert ${CUSTOM_CERTS_DIR} collections
758 if [ "${SSL_MODE}" = "bring-your-own" ]; then
759 copy_custom_cert ${CUSTOM_CERTS_DIR} ${R}
763 # webshell role is just a nginx vhost, so it has no state
764 if [ "${R}" != "webshell" ]; then
765 grep -q "arvados.${R}" ${S_DIR}/top.sls || echo " - arvados.${R}" >> ${S_DIR}/top.sls
768 if [ "${R}" = "workbench" ]; then
769 grep -q "logrotate_wb1" ${P_DIR}/top.sls || echo " - logrotate_wb1" >> ${P_DIR}/top.sls
771 grep -q "nginx_passenger" ${P_DIR}/top.sls || echo " - nginx_passenger" >> ${P_DIR}/top.sls
772 grep -q "nginx_${R}_configuration" ${P_DIR}/top.sls || echo " - nginx_${R}_configuration" >> ${P_DIR}/top.sls
773 # Special case for keepweb
774 if [ ${R} = "keepweb" ]; then
775 grep -q "nginx_download_configuration" ${P_DIR}/top.sls || echo " - nginx_download_configuration" >> ${P_DIR}/top.sls
776 grep -q "nginx_collections_configuration" ${P_DIR}/top.sls || echo " - nginx_collections_configuration" >> ${P_DIR}/top.sls
779 if [ "${SSL_MODE}" = "lets-encrypt" ]; then
780 if [ "${USE_LETSENCRYPT_ROUTE53}" = "yes" ]; then
781 grep -q "aws_credentials" ${P_DIR}/top.sls || echo " - aws_credentials" >> ${P_DIR}/top.sls
783 grep -q "letsencrypt" ${P_DIR}/top.sls || echo " - letsencrypt" >> ${P_DIR}/top.sls
784 grep -q "letsencrypt_${R}_configuration" ${P_DIR}/top.sls || echo " - letsencrypt_${R}_configuration" >> ${P_DIR}/top.sls
786 # As the pillar differ whether we use LE or custom certs, we need to do a final edition on them
787 # Special case for keepweb
788 if [ ${R} = "keepweb" ]; then
789 for kwsub in download collections; do
790 sed -i "s/__CERT_REQUIRES__/cmd: create-initial-cert-${kwsub}.${CLUSTER}.${DOMAIN}*/g;
791 s#__CERT_PEM__#/etc/letsencrypt/live/${kwsub}.${CLUSTER}.${DOMAIN}/fullchain.pem#g;
792 s#__CERT_KEY__#/etc/letsencrypt/live/${kwsub}.${CLUSTER}.${DOMAIN}/privkey.pem#g" \
793 ${P_DIR}/nginx_${kwsub}_configuration.sls
796 sed -i "s/__CERT_REQUIRES__/cmd: create-initial-cert-${R}.${CLUSTER}.${DOMAIN}*/g;
797 s#__CERT_PEM__#/etc/letsencrypt/live/${R}.${CLUSTER}.${DOMAIN}/fullchain.pem#g;
798 s#__CERT_KEY__#/etc/letsencrypt/live/${R}.${CLUSTER}.${DOMAIN}/privkey.pem#g" \
799 ${P_DIR}/nginx_${R}_configuration.sls
802 grep -q "ssl_key_encrypted" ${P_DIR}/top.sls || echo " - ssl_key_encrypted" >> ${P_DIR}/top.sls
803 # As the pillar differ whether we use LE or custom certs, we need to do a final edition on them
804 # Special case for keepweb
805 if [ ${R} = "keepweb" ]; then
806 for kwsub in download collections; do
807 sed -i "s/__CERT_REQUIRES__/file: extra_custom_certs_file_copy_arvados-${kwsub}.pem/g;
808 s#__CERT_PEM__#/etc/nginx/ssl/arvados-${kwsub}.pem#g;
809 s#__CERT_KEY__#/etc/nginx/ssl/arvados-${kwsub}.key#g" \
810 ${P_DIR}/nginx_${kwsub}_configuration.sls
811 grep -q ${kwsub} ${P_DIR}/extra_custom_certs.sls || echo " - ${kwsub}" >> ${P_DIR}/extra_custom_certs.sls
814 sed -i "s/__CERT_REQUIRES__/file: extra_custom_certs_file_copy_arvados-${R}.pem/g;
815 s#__CERT_PEM__#/etc/nginx/ssl/arvados-${R}.pem#g;
816 s#__CERT_KEY__#/etc/nginx/ssl/arvados-${R}.key#g" \
817 ${P_DIR}/nginx_${R}_configuration.sls
818 grep -q ${R} ${P_DIR}/extra_custom_certs.sls || echo " - ${R}" >> ${P_DIR}/extra_custom_certs.sls
821 # We need to tweak the Nginx's pillar depending whether we want plain nginx or nginx+passenger
822 sed -i "s/__NGINX_INSTALL_SOURCE__/${NGINX_INSTALL_SOURCE}/g" ${P_DIR}/nginx_passenger.sls
826 echo " - extra.shell_sudo_passwordless" >> ${S_DIR}/top.sls
827 echo " - extra.shell_cron_add_login_sync" >> ${S_DIR}/top.sls
828 grep -q "docker" ${S_DIR}/top.sls || echo " - docker.software" >> ${S_DIR}/top.sls
829 grep -q "arvados.${R}" ${S_DIR}/top.sls || echo " - arvados.${R}" >> ${S_DIR}/top.sls
831 grep -q "docker" ${P_DIR}/top.sls || echo " - docker" >> ${P_DIR}/top.sls
833 "dispatcher" | "keepbalance" | "keepstore")
835 grep -q "arvados.${R}" ${S_DIR}/top.sls || echo " - arvados.${R}" >> ${S_DIR}/top.sls
837 # ATM, no specific pillar needed
840 echo "Unknown role ${R}"
847 if [ "${DUMP_CONFIG}" = "yes" ]; then
848 # We won't run the rest of the script because we're just dumping the config
852 # Now run the install
853 salt-call --state-output=mixed --local state.apply -l ${LOG_LEVEL}
855 # Finally, make sure that /etc/hosts is not overwritten on reboot
856 if [ -d /etc/cloud/cloud.cfg.d ]; then
857 # TODO: will this work on CentOS?
858 sed -i 's/^manage_etc_hosts: true/#manage_etc_hosts: true/g' /etc/cloud/cloud.cfg.d/*
861 # Leave a copy of the Arvados CA so the user can copy it where it's required
862 if [ "${SSL_MODE}" = "self-signed" ]; then
863 echo "Copying the Arvados CA certificate '${CLUSTER}.${DOMAIN}-arvados-snakeoil-ca.crt' to the installer dir, so you can import it"
864 if [ "x${VAGRANT}" = "xyes" ]; then
865 cp /etc/ssl/certs/arvados-snakeoil-ca.pem /vagrant/${CLUSTER}.${DOMAIN}-arvados-snakeoil-ca.pem
867 cp /etc/ssl/certs/arvados-snakeoil-ca.pem ${SCRIPT_DIR}/${CLUSTER}.${DOMAIN}-arvados-snakeoil-ca.crt
871 if [ "x${VAGRANT}" = "xyes" ]; then
872 # If running in a vagrant VM, also add default user to docker group
873 echo "Adding the vagrant user to the docker group"
874 usermod -a -G docker vagrant
877 # Test that the installation finished correctly
878 if [ "x${TEST}" = "xyes" ]; then
880 # If we use RVM, we need to run this with it, or most ruby commands will fail
882 if [ -x /usr/local/rvm/bin/rvm-exec ]; then
883 RVM_EXEC="/usr/local/rvm/bin/rvm-exec"
885 ${RVM_EXEC} ./run-test.sh